def factorialImperative(number) {
  def fact = 1
  for(e in 1..number) { fact *= e }
  fact
}

def factorialRecursive(number) {
  if (number == 1)
    number
  else
    number * factorialRecursive(number - 1)
}

//Groovy does not support tail recursion at this time
// so this is of little help
def factorialRecursiveTail(fact, number) {
  if (number == 1)
    fact
  else
    factorialRecursiveTail(number * fact, number - 1)
}

def factorialImmutable(number) {
  (1..number).inject(1) { fact, e -> fact * e }
}

println factorialImperative(5)
println factorialRecursive(5)
println factorialImperative(5000)
//println factorialRecursive(5000) //StackOverflow
println factorialRecursiveTail(1, 5)
//println factorialRecursiveTail(1, 5000) //StackOverflow
println factorialImmutable(5)
println factorialImmutable(5000)